/**
 * Structure.java
 *
 * File generated from the LDAStructure::Structure uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ldap.model;

import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;

// End of user code

/**
 * Description of the class Structure.
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Structure", propOrder = { "structures", "name", "version" })
@XmlRootElement(name = "LDAPStructure")
public class Structure implements java.io.Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@XmlElementRefs({ @XmlElementRef(name = "objectClass", type = JAXBElement.class),
			@XmlElementRef(name = "attributeType", type = JAXBElement.class) })
	public List<java.io.Serializable> structures;
	@XmlAttribute(name = "name", required = true)
	public String name;
	@XmlAttribute(name = "version")
	public String version;

	/**
	 * Return structures.
	 * 
	 * @return structures
	 */
	public List<java.io.Serializable> getStructures() {
		if (structures == null) {
			structures = new ArrayList<java.io.Serializable>();
		}
		return structures;
	}

	/**
	 * Set a value to attribute structures.
	 * 
	 * @param structures
	 *            .
	 */
	public void setStructures(List<java.io.Serializable> structures) {
		this.structures = structures;
	}

	/**
	 * Add a structures to the structures collection.
	 * 
	 * @param structures_elt
	 *            Element to add.
	 */
	public void addStructures(java.io.Serializable structures_elt) {
		this.structures.add(structures_elt);
	}

	/**
	 * Remove a structures to the structures collection.
	 * 
	 * @param structures_elt
	 *            Element to remove
	 */
	public void removeStructures(java.io.Serializable structures_elt) {
		this.structures.remove(structures_elt);
	}

	/**
	 * Return objectClass.
	 * 
	 * @return objectClass
	 */
	public List<ObjectClasses> getObjectClass() {
		List<ObjectClasses> objectClass_el = new ArrayList<ObjectClasses>();
		for (java.io.Serializable obj : this.getStructures()) {
			if (obj instanceof javax.xml.bind.JAXBElement) {
				if (((javax.xml.bind.JAXBElement<?>) obj).getName().getLocalPart().equals("objectClass")) {
					objectClass_el.add((ObjectClasses) ((javax.xml.bind.JAXBElement<?>) obj).getValue());
				}
			}
		}

		return objectClass_el;
	}

	public void addObjectClass(ObjectClasses obj) {
		ObjectFactory of = new ObjectFactory();
		JAXBElement<ObjectClasses> jobj = of.createStructureObjectClass(obj);
		this.getStructures().add(jobj);
	}

	/**
	 * Return attributeType.
	 * 
	 * @return attributeType
	 */
	public List<AttributeTypes> getAttributeType() {
		List<AttributeTypes> attributeType_el = new ArrayList<AttributeTypes>();
		for (java.io.Serializable obj : this.getStructures()) {
			if (obj instanceof javax.xml.bind.JAXBElement) {
				if (((javax.xml.bind.JAXBElement<?>) obj).getName().getLocalPart().equals("attributeType")) {
					attributeType_el.add((AttributeTypes) ((javax.xml.bind.JAXBElement<?>) obj).getValue());
				}
			}
		}

		return attributeType_el;
	}

	public void addAttributeType(AttributeTypes obj) {
		ObjectFactory of = new ObjectFactory();
		JAXBElement<AttributeTypes> jobj = of.createStructureAttributeType(obj);
		this.getStructures().add(jobj);
	}

	/**
	 * Return name.
	 * 
	 * @return name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Set a value to attribute name.
	 * 
	 * @param name
	 *            .
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Return version.
	 * 
	 * @return version
	 */
	public String getVersion() {
		return version;
	}

	/**
	 * Set a value to attribute version.
	 * 
	 * @param version
	 *            .
	 */
	public void setVersion(String version) {
		this.version = version;
	}

	public static Structure xmlToJava(InputStream is) throws JAXBException, IOException {
		JAXBContext context = JAXBContext.newInstance(Structure.class);
		Unmarshaller u = context.createUnmarshaller();
		Structure myStructure = (Structure) u.unmarshal(is);
		return myStructure;
	}

	public static String javaToXml(Structure inStructure) throws JAXBException {
		JAXBContext context = JAXBContext.newInstance(Structure.class);
		Marshaller m = context.createMarshaller();
		m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
		StringWriter writer = new StringWriter();
		m.marshal(inStructure, writer);
		return writer.toString();
	}

}